package com.eactive.eai.batch.job.jobItem.billimg;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.encrypt.EncryptManager;
import com.eactive.eai.common.exception.ExceptionUtil;


public class RECV_BI0200 extends DefaultTelegram implements TelegramService
{
    /**
     * 생성자
     */
	
    public RECV_BI0200() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        try{
         //송신자 암호 유효성 확인
	        String sendPwd = new String ((byte[]) al_Field.get(10));	        
	        if (sendPwd == null || sendPwd.length() <= 0) {
	            super.setResolveResponseCode(TelegramKeys.BI_RES_CODE_SENDER_PWD_ERROR);
	
	            String[] msgArgs = new String[1];
	            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
	            String errCode = "BECEAIFJI010";
	            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
	            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
	
	            return false;
	        }
	        //요구송수신 테스트를 위해 암호 복호화
	        //결재원과 테스트시에는 해당 클래스는 실행되지 않음.
			Properties telegramInfo = getTelegramInfo();
	
			String cypherYn = telegramInfo.getProperty(TelegramKeys.CMS_CIPHER_USE);
	        if (( cypherYn != null) &&cypherYn.equalsIgnoreCase("Y") ) {
	        	//전송자명은 앞에서 7자리이며 7자리 미만은 Z로 채움..
	        	String passwd = EncryptManager.getInstance().getDeEncryptPwd(sendPwd,
	        															telegramInfo.getProperty(TelegramKeys.BANK_CODE).substring(1,3),
	        															TelegramKeys.getYYYYMMddHHmmss().substring(2,8),
	        															(batchDoc.getBatchMsg().getHeader().getUserID()+"ZZZZZZZ").substring(0,8)
	        			                                                );
	        	logger.debug("{"+logHeader+"} RECV_BI0200 ] PASSWD : ["+passwd+"], getUserPassword : ["+batchDoc.getBatchMsg().getHeader().getUserPassword()+"]");   
	        	
	        	if (!passwd.startsWith(batchDoc.getBatchMsg().getHeader().getUserPassword())){
	        		super.setResolveResponseCode(TelegramKeys.BI_RES_CODE_SENDER_PWD_ERROR);
	        		
		            String[] msgArgs = new String[1];
		            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
		            String errCode = "BECEAIFJI010";
		            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
		            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
		            return false;
	        		
	        	}
	        }
        }catch(Exception e){
            String errMsg = ExceptionUtil.getErrorCode ("RECV_BI0200] occure exception at doValidation ");
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e );
            setConditionTxt(TelegramKeys.ERROR);
            return false;
        }
        return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<8; i++) { //어음이미지 전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=8; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex );
            setConditionTxt(TelegramKeys.ERROR);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(4);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(7);
    }

}
